//+------------------------------------------------------------------+
//|                                          Trend Catcher v0.50.mq4 |
//|                                       Copyright  2008 Tom Balfe |
//|                   http://www.forex-tsd.com/members/nittany1.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Tom Balfe"
#property link      "http://www.forex-tsd.com/members/nittany1.html"

//+------------------------------------------------------------------+
//| USER ADJUSTABLE STUFF                                            |
//+------------------------------------------------------------------+

extern  string  TopOfSetting          = "=== Trend Catcher v0.50 EA ===";
extern  int     MagicNumber           = 965843;

extern  string  Order_Settings        = "=== Order Settings ===";
extern  double  StaticLots            = 0.01;
extern  int     Slippage              = 5;
extern  int     TP                    = 50;
extern  int     SL                    = 250;

extern  string  MM_Settings           = "=== Money Management ===";
extern  bool    UseMM                 = false;
extern  int     PercentAtRisk         = 3;

//+------------------------------------------------------------------+
//| DON'T CHANGE BELOW HERE                                          |
//+------------------------------------------------------------------+
//| Program initializes and deinitializes here.                      |
//+------------------------------------------------------------------+
string        EAComment   = "Trend Catcher v0.50 EA";
string        EATitle     = "TREND CATCHER v0.50 EA  2008 TOM BALFE";
int           OpenOrders  = 1;
datetime      PreviousBar;

int init()
  {
  ObjectCreate("Title",OBJ_LABEL,0,0,0);
  ObjectSet("Title",OBJPROP_XDISTANCE,325);
  ObjectSet("Title",OBJPROP_YDISTANCE,2);
  ObjectSetText("Title",EATitle,9,"Lucida Sans Regular",PaleTurquoise);

  return(0);
  }

int deinit()
  {
    if (TotalOpenOrders() > 0)
    {
    CloseAll();
    } 
  
  ObjectsDeleteAll();
  ObjectDelete("Title");
    
  return(0);
  }

int start()
  {
  //--- Hi-Low 
  double HLbuy  = iCustom(NULL,0,"Hi-Lo",30,300,1,0); // buy
  double HLsell = iCustom(NULL,0,"Hi-Lo",30,300,0,0); // sell
  
  //--- Order Entry ---//
  
  if (NewBar() == true) {
  //---------------- check indicators and look for a CLOSE ---//
    if (TotalOpenOrders() == OpenOrders)
    {
      if (OrderType() == OP_BUY) {
        if (HLsell > 0) { CloseAll(); }
      }
    
      if (OrderType() == OP_SELL) {
        if (HLbuy > 0) { CloseAll(); }
      }
    }
  
    //---------------- check indicators and look for a ORDER ENTRY ---//
    if (TotalOpenOrders() < OpenOrders)
    {
      //-- BUY
      if (HLbuy > 0) {
        OrderSend(Symbol(),OP_BUY,LotSize(),Ask,Slippage,Ask-SL*Point,Ask+TP*Point,EAComment,MagicNumber,0,Lime);  
      }
    
      //-- SELL
      if (HLsell > 0) {
        OrderSend(Symbol(),OP_SELL,LotSize(),Bid,Slippage,Bid+SL*Point,Ask-TP*Point,EAComment,MagicNumber,0,Red);
      }
    }
  }
  ShowInfo();
    
  return(0);
  }

//+------------------------------------------------------------------+
//| COMMON FUNCTIONS                                                 |
//+------------------------------------------------------------------+
//| The expert will call these from the main loop.                   |
//+------------------------------------------------------------------+

//+-----------------------------------------------------+
//|           new bar                                   |
//+-----------------------------------------------------+
bool NewBar()
{
  if(PreviousBar<Time[0])
  {
    PreviousBar = Time[0];
    return(true);
  }
  else
  {
    return(false);
  }
  return(false);  
}

//+-----------------------------------------------------+
//|           calculate lot size                        |
//+-----------------------------------------------------+
double LotSize()
{
  if (UseMM == true) 
    { double Lots = MathCeil(AccountFreeMargin() *  PercentAtRisk / 1000) / 100; }
  
  else { Lots = StaticLots; }
  
  return(Lots);  
}

//+-----------------------------------------------------+
//|           close all                                 |
//+-----------------------------------------------------+
//| Finds any open orders & closes them                 |
//+-----------------------------------------------------+
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type = OrderType();
    
    if (OrderSymbol()==Symbol() && (OrderMagicNumber() == MagicNumber))  
    {
      //-- Close open BUYs
      if (type == OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,CornflowerBlue);
      //-- Close open SELLS
      if (type == OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,CornflowerBlue);
    }
  }
  return;
}

//+-----------------------------------------------------+
//|           calculate open orders                     |
//+-----------------------------------------------------+
int TotalOpenOrders()
{
  int j = 0;
  j=OrdersTotal();
  int TotalOpenOrders = 0;
   
  if(j==0) { return (0); }
  
  else
  {
    for(;j>=0;j--)
      {
      RefreshRates();
      OrderSelect(j,SELECT_BY_POS);
      if(OrderMagicNumber()==MagicNumber)
      {
        TotalOpenOrders++;
      }
    }
  }
  return(TotalOpenOrders);
}

//+-----------------------------------------------------+
//|           show summary panel on chart               |
//+-----------------------------------------------------+
void ShowInfo()
{
  Comment("...::: Trend Catcher v0.50 :::...\n",
          "Copyright  2008 Tom Balfe\n",
          "Currency Pair: ", Symbol(),"\n",
          "Price:  ",NormalizeDouble(Bid,4),"\n",
          "Date: ",Month(),"-",Day(),"-",Year()," Server Time: ",Hour(),":",Minute(),":",Seconds(),"\n",
          "Minimum Lot Size: ",MarketInfo(Symbol(),MODE_MINLOT));
  return(0);
}